structure RBTreeUtil =
struct
   open RBTree

   fun depth tree =
      let
	 fun depth' tree =
	    caseColorCardBroken tree
	    {Leaf = fn () => 0,
	     Node = fn (_,l,_,r) => 
	            1 + Int.max (depth' l,
				 depth' r)}
      in
	 depth' (coerceColorCardBroken tree)
      end

   fun size tree =
      let
	 fun size' tree =
	    caseColorCardBroken tree
	    {Leaf = fn () => 0,
	     Node = fn (_,l,_,r) => 
	            1 + (size' l) + (size' r)}
      in
	 size' (coerceColorCardBroken tree)
      end
	    

   fun toString tree =
      let
	 fun toString' (tree, sp, spl, spr) =
	    let
	       fun leaf () = sp ^ "-b"
	       fun node (c, l, e, r) =
		  let
		     val sl = 
			toString' (l,
				   spl ^ " /",
				   spl ^ "  ",
				   spl ^ " |")
		     val sr =
			toString' (r,
				   spr ^ " \\",
				   spr ^ " |",
				   spr ^ "  ")
		  in
		     concat [sl, "\n",
			     sp,"-",
			     Color.caseColor c {Red=fn()=>"r",Black=fn()=>"b"},
			     ":",Int.toString e,
			     "\n", sr]
		  end
	    in
	       caseColorCardBroken tree 
	       {Leaf=leaf,Node=node}
	    end
      in
	 toString' (coerceColorCardBroken tree, "", "", "")
      end

end